/*
Questa classe ha il compito di effettuare una serie di controlli
sul testo html passato al metodo run, e di importarlo nell'oggetto
JScrollPane settato ocme editor html.
Nel caso in cui si verifichi una eccezione durante la fase di parse
del codice HTML, significa che tale codice contiene dei caratteri errati.
Si esegue allora  una ripulitira ciclica ad oltranza fino a che l'import
non da errori.
Tali prove vengono effettuate su un oggetto JScrollPane locale alla classe.
Nel momento in cui tutto  ok, si assegna tale testo al JScrollPane della
classe HTMLEditor.

*/



import com.sun.java.swing.*;
import com.sun.java.swing.text.html.*;
import com.sun.java.swing.text.html.HTMLEditorKit;
import com.sun.java.swing.text.StyledEditorKit.*;
import com.sun.java.swing.text.*;

import java.awt.event.ActionEvent;
import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;



public class HtmlLoader extends Thread{



  String HTMLCode;
  HTMLEditor HE;
  private JEditorPane text;



  public HtmlLoader(String hc, HTMLEditor he){
    HTMLCode=hc;
    HE=he;
  }// fine costruttore



  public void run(){

    // Legge il codice html passato dall'esterno e lo mette
    // nel documento del JTextPanel.
    // Alcuni caratteri illegali potrebbero generare eccezioni: in tal
    // caso si cerca di determinare quale carattere non va bene,
    // lo si elimina dal codice html e si riprova.
    // L'operazione viene tentata fino a che non vengono generate eccezioni
    //
    boolean done=false;
    int cycle=1;
    // Formattazione secondo la forma canonica
    HTMLCode="<html><body>"+HTMLCode+ "</body></html>";
    System.out.println("Sostituisce i <br>");
    int index=HTMLCode.indexOf("<BR>");
    while (index>-1){
      HTMLCode=HTMLCode.substring(0,index)+"<P></P>"+HTMLCode.substring(index+4);
      index=HTMLCode.indexOf("<BR>",index+1);
    }

    text = new JEditorPane();
    text.setContentType("text/html");

    // Importazione del testo in HTML.
    // Il ciclo infinito che continua a provare l'import del testo fino a
    // che non si sono verificati altri errori.
    // Un errore si pu verificare se nel codice html  presente un carattere
    // non stampabile o comunque non valido. Il parser html  molto scrupoloso
    // da questo punto di vista.
    // Ad ogni errore, individua il carattere che lo ha provocato
    // e lo elimina dal testo.
    while(!done){
      System.err.println("Provo l'import numero "+(cycle++) +",   del testo lungo "+HTMLCode.length());
      try{
        CharArrayReader car= new CharArrayReader(HTMLCode.toCharArray());
        Document doc= text.getDocument();
        EditorKit ed= text.getEditorKit();
        ed.read(car, doc, 0);

        // se arriva qui senza generare eccezioni, allora il testo
        // era pulito, e termina il ciclo
        done=true;
      }// fine try
      catch (IOException e) {
        // Controlliamo se l'errore verificatosi  dovuto ad un
        // carattere illegale contenuto nel testo. In questo caso infatti
        // il messaggio della eccezione  qualcosa del tipo
        // << Lexical error at line 6, column 41.  Encountered: "0" (48), after : "" >>
        // si lavora con il codice ascii che si trova tra parentesi  ^^

        // Per prima cosa visualizza un messaggio di avvertimento
        System.out.println("Eccezione :"+e);
        String user_message="<P>Attenzione sono stati trovati dei caratteri illegali nell'articolo. </P><P> Si procede alla ripulitura e formattazione del testo </P><P> Passaggio "+cycle+"</P>";
        user_message="<HTML> <BODY> "+user_message+"</BODY> </HTML>";
        HE.setHtmlCode(user_message);



        String err_message=e+"";
        int index_err_message=err_message.indexOf("Encountered:");
        char bad_char=' ';

        // se ha trovato la stringa Encountered
        // ricava il carattere in questione
         if (index_err_message >-1){
         int start_index_bad_char_code=err_message.indexOf('(',index_err_message+1)+1;
         int end_index_bad_char_code=err_message.indexOf(')',start_index_bad_char_code);
         int bad_char_code=Integer.parseInt(err_message.substring(start_index_bad_char_code,end_index_bad_char_code));
         bad_char= (char) bad_char_code; //Character.forDigit(bad_char_code,10);

         //err_message=err_message.substring(index_err_message);
         System.out.println("Trovato il carattere illegale *"+bad_char+"*");
        }

        String s=HTMLCode;
        HTMLCode="";
        for (int i=0; i<s.length(); i++){
          char c=s.charAt(i);

          // 8217  un apostrofo  particolare che da errore
          // ma che deve comparire.
          // lo si sostituisce con '
          // Si sottoindente che in questo caso c  un bad_char
          if((int)c==8217 ){
             c='\'';
             System.out.println("Metto apostrofo");
          }

          if(c != bad_char){
            HTMLCode=HTMLCode+c;
          }
          else
            System.out.println(i+" Non copio "+(int)bad_char);
        }

      }// fine catch IOException

      catch (BadLocationException e) {
        System.err.println("BadLocationException nel caricamento html \n" + e);
        done=true;
      }


      catch (Exception e) {
        System.err.println("Eccezione nel caricamento html \n" + e);
        done=true;
      }


    }// fine while

    // adesso il codice HTML  stato ripulito da caratteri
    // dannosi. Lo si pu immettere nel HTMLEditor
    HE.text.setEditable(true);
    HE.setHtmlCode(HTMLCode);

  }// fine run

}// fine classe
